image: python:3.8.8-slim-buster

stages:
    -   lint
    -   test
    -   release

variables:
    GIT_DEPTH: 1
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache"

cache:
    paths:
        - .cache/

flake8-default:
    image: python:3.8.8-slim-buster
    before_script:
        - python -m pip install --quiet flake8
    cache: {}
    script:
        - python -m flake8 --max-line-length=125 --extend-ignore=E251 --exclude=mosaik_schedule_flocker/flocker/data/api.yaml.py mosaik_schedule_flocker test/ setup.py
    stage: lint

flake8-dlint:
    image: python:3.8.8-slim-buster
    before_script:
        - python -m pip install --quiet dlint
    cache: {}
    script:
        - python -m flake8 --select=DUO --extend-ignore=DUO102 mosaik_schedule_flocker test/ setup.py
    stage: lint

flake8-mypy:
    image: python:3.8.8-slim-buster
    before_script:
        - python -m pip install --quiet flake8-mypy
    cache: {}
    script:
        - python -m flake8 --select=T400,T484,T498,T499 mosaik_schedule_flocker test/ setup.py
    stage: lint

python37:
    image: python:3.7.10-slim-buster
    stage: test
    script:
    -   python3.7 -m venv venv
    -   venv/bin/python -m pip install --quiet --upgrade -r requirements.d/venv.txt
    -   venv/bin/python -m tox -e py37

python38:
    image: python:3.8.8-slim-buster
    stage: test
    script:
    -   python3.8 -m venv venv
    -   venv/bin/python -m pip install --quiet --upgrade -r requirements.d/venv.txt
    -   venv/bin/python -m tox -e py38

python39:
    image: python:3.9.2-slim-buster
    stage: test
    script:
    -   python3.9 -m venv venv
    -   venv/bin/python -m pip install --quiet --upgrade -r requirements.d/venv.txt
    -   venv/bin/python -m tox -e py39

wheel:
    image: python:3.9.2-slim-buster
    script:
        -   python -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   python setup.py bdist_wheel
        -   python -m pip install --quiet --upgrade twine
        -   twine upload --verbose dist/*
    stage: release
    variables:
        TWINE_USERNAME: $TWINE_USERNAME
        TWINE_PASSWORD: $TWINE_PASSWORD
